%{
#open "fichia";; 
#open "scanord";;
%}
%token PI PD EOL IMPLICA AND COMA EMPTY SAVE IN DROP PROOF LIST SALIR
%token <string> NOMBREMAY NOMBREMIN
%start Entrada
%type <fichia__ent_ord> Entrada
%%
	Entrada:
		Linea EOL			{$1}
	;

	Linea: 
		EMPTY		{ORD (Empty,[])}
		|SAVE Expr	{ORD (Save,[$2])}
		|IN Expr	{ORD (In,[$2])}
		|DROP Expr	{ORD (Drop,[$2])}
		|PROOF Expr	{ORD (Proof,[$2])}
		|LIST		{ORD (List,[])}
		|SALIR		{ORD (Salir,[])}
	;

	Expr: 
		Atomica				{Exp ($1,[])}
		|Antecedentes IMPLICA Atomica	{Exp ($3,$1)}
	;

	Antecedentes: 
		Atomica {[$1]}
		|Atomica AND Antecedentes	{$1::$3}
	;

	Atomica:
		NOMBREMIN PI Terms PD 		{At ($1,$3)}
	;

	Terms:
		NOMBREMIN 			{[Con $1]}
		|NOMBREMAY 			{[Var $1]}
		|NOMBREMIN COMA Terms 		{(Con $1)::$3}
		|NOMBREMAY COMA Terms 		{(Var $1)::$3}
	;;
		
%%
