{
#open "parord";;
exception Error_lexico;;
}

rule token_ord = parse
	`(` {PI}
	|`)`  {PD}
	|`,`  {COMA}
	|"->"  {IMPLICA}
	|"empty"	{EMPTY}
	|"save"		{SAVE}
	|"in"		{IN}
	|"drop"		{DROP}
	|"proof"	{PROOF}
	|"list"		{LIST}
	|"exit"	{SALIR}
	|`^` {AND}
	|[`A`-`Z`]+ {NOMBREMAY (get_lexeme (lexbuf))}
	|[`a`-`z`]+ {NOMBREMIN (get_lexeme (lexbuf))}
	|[` ` `\t`]+ {token_ord lexbuf}
	|[`\n`]  {EOL}
	|_ {print_string "Error in order line";
	    print_newline();
	    print_string "This is the mistake : ";
	    print_string (get_lexeme (lexbuf));print_newline();
	    flush std_out;raise Error_lexico
	}
;;
